         TITLE 'DUMB TERMINAL EMULATOR'
         ORG   0C900H
MAIN:    CALL  PSCAN         ;THIS IS BASICALLY THE TERMINAL ROUTINE
         STA   IPORT         ;FROM SOLOS
         CALL  PSCAN
         STA   OPORT
TRM1:    CALL  KSTAT
         JZ    TIN1
         MOV   B,A
         CPI   MODE
         JZ    COMN1
TOUT1:   CALL  SOUT
TIN1:    CALL  SINP
         JZ    TRM1
         ANI   7FH           ;ONLY ASCII ACCEPTED
         MOV   B,A
         CPI   ASCR          ;CR IS A SPECIAL CHARACTER...
         JNZ   TIN3          ;IT WASN'T A CR, BYPASS COLUMN TEST...
         LDA   NCHAR         ;HAS A CR ALREADY PUT US IN COLUMN 1 ???
         CPI   0             ;THIS WILL TELL US
         JZ    TRM1          ;IT IS COLUMN 1, DON'T PROCESS IT
TIN3:    CALL  VDMO
         JMP   TRM1
;
;    THIS VDM DRIVER BYPASSES THE STANDARD DRIVER SO THAT
;    SPECIAL CHARACTERS MAY BE DISPLAYED.
;
VDMO:    PUSH  H
         PUSH  D
         PUSH  B             ;SAVE EVERYBODY
         LXI   H,TABL
         CALL  TSRCH         ;SEARCH TABLE FOR CONTROL CHAR
         JMP   GOBACK        ;BACK TO SOLOS TO DISPLAY THE CHAR
PBELL:   MOV   A,B           ;MAKE IT AN ASCII 'BEL' CODE
         OUT   KDATA         ;SEND THEM TO THE ( NONEXISTENT ) ALARM PORT
         RET
PLF:     IN    SENSE         ;CHECK SENSE SWITCH
         ANI   2
         JNZ   PDOWN         ;IF OFF, GO AHEAD AND SCROLL
         LDA   LINE          ;OTHERWISE, LET IT WRAP
         INR   A
         ANI   15
         JNZ   CUR
         JMP   SROL
;
;    THIS JUMP TABLE REFLECTS VERSION
;    1.3 OF SOLOS (APRIL 1977 RELEASE)
;
TABL:    DB    FF1
         DW    PERSE
         DB    SUB1
         DW    PUP
         DB    ACK1
         DW    PRIT
         DB    NAK1
         DW    PLEFT
         DB    SOH1
         DW    PHOME
         DB    ASCR
         DW    PCR
         DB    LF1
         DW    PLF
         DB    BEL1
         DW    PBELL
         DB    BS1
         DW    PLEFT
         DB    0
;
;    CHARACTER DEFINTIONS
;
FF1      EQU   0CH
SUB1     EQU   1AH
ACK1     EQU   06H
NAK1     EQU   15H
SOH1     EQU   01H
ASCR     EQU   0DH
LF1      EQU   0AH
VT1      EQU   0BH
DLE1     EQU   10H
BEL1     EQU   07H
STX1     EQU   02H
EOT1     EQU   04H
BS1      EQU   08H
MODE     EQU   80H
;
;    SOLOS SYSTEM EQUATES
;
SINP     EQU   0C01FH
SOUT     EQU   0C019H
VDMEM    EQU   0CC00H
COMN1    EQU   0C1C0H
CUR      EQU   0C0D1H
CURSC    EQU   0C0CFH
GOBK     EQU   0C07CH
GOBACK   EQU   0C06BH
LINE     EQU   0C809H
NCHAR    EQU   0C808H
PDOWN    EQU   0C0CBH
PERSE    EQU   0C0D5H
PUP      EQU   0C104H
PRIT     EQU   0C115H
PLEFT    EQU   0C10BH
PHOME    EQU   0C0E5H
PCR      EQU   0C147H
CREM     EQU   0C136H
PSCAN    EQU   0C310H
OPORT    EQU   0C807H
IPORT    EQU   0C806H
KSTAT    EQU   0C02EH
SROL     EQU   0C0B0H
CHAR     EQU   0C094H
TSRCH    EQU   0C082H
KDATA    EQU   0FCH
SENSE    EQU   0FFH
         END
